<script lang="ts">
import Vue from 'vue';
import type { PropType } from 'vue';
import { IsMobileMixin } from '~/mixins';

interface HeroImage {
  src: string;
  alt?: string;
}

interface HeroButton {
  text: string;
  href: string;
  variant?: string;
  icon?: {
    name: string;
    variant: string;
    size?: string;
  };
}

export default Vue.extend({
  mixins: [IsMobileMixin],
  props: {
    gartnerMQLanding: {
      type: Boolean,
      required: false,
      default: false,
    },
    header: {
      type: String,
      required: true,
    },
    description: {
      type: String,
      required: false,
      default: '',
    },
    image: {
      type: Object as PropType<HeroImage>,
      required: true,
    },
    button: {
      type: Object as PropType<HeroButton>,
      required: false,
      default: null,
    },
  },
});
</script>

<template>
  <div id="hero-container">
    <SlpContainer>
      <div class="hero-wrapper">
        <!-- Mobile background image -->
        <div v-show="isMobile" class="hero-image__mobile">
          <img :src="image.mobileSrc" :alt="image.alt" />
        </div>
        <div class="hero-text">
          <div class="animation-wrapper">
            <SlpTypography
              :variant="isMobile ? 'heading4-bold' : 'heading2-bold'"
              tag="h1"
              class="slp-mb-24 animated"
              ><span v-html="header"></span
            ></SlpTypography>
          </div>
          <div class="animation-wrapper hero-description">
            <SlpTypography variant="body1" tag="h2" class="slp-mb-24 animated">
              <span v-html="$md.render(description)"></span
            ></SlpTypography>
          </div>
          <div class="animation-wrapper">
            <SlpButton
              :href="button.href"
              :variant="button.variant"
              class="animated"
              data-ga-name="report"
              data-ga-location="hero"
              >{{ button.text }}
              <SlpIcon v-if="button.icon" v-bind="button.icon" class="slp-ml-8"
            /></SlpButton>
          </div>
        </div>
        <!-- Desktop background image -->
        <div
          v-show="!isMobile"
          :class="`hero-image ${gartnerMQLanding ? 'gartner-mq' : ''}`"
        >
          <img :src="image.src" :alt="image.alt" />
        </div>
      </div>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
#hero-container {
  margin: 0;
  max-width: 100vw;
  background-color: #2f2a6b;
  overflow: hidden;
}
.hero-wrapper {
  position: relative;
  padding: 42px 16px;
  min-height: 65vh;

  @media (max-width: $breakpoint-md) {
    display: grid;
    grid-template-columns: 1fr;
  }

  .hero-description {
    :deep {
      ul {
        list-style: none;
        margin-bottom: $spacing-8;
      }

      li {
        display: flex;
        align-items: center;
        list-style: none;
        font-size: $spacing-16;
        line-height: $spacing-24;
        margin: $spacing-16 0;

        &:before {
          content: '';
          flex-shrink: 0;
          margin-right: $spacing-8;
          height: $spacing-16;
          width: $spacing-16;
          background-size: contain;
          background-repeat: no-repeat;
          background-image: url('/nuxt-images/icons/list-check-alt.svg');

          @media (max-width: $breakpoint-lg) {
            margin-right: $spacing-16;
          }
        }
      }
    }
  }
  .hero-text {
    padding-top: $spacing-32;
    position: relative;
    z-index: 2;

    @media (min-width: $breakpoint-md) {
      padding-top: $spacing-32;
      max-width: 60%;
    }

    .animation-wrapper {
      overflow-y: clip;
      color: white;

      .animated {
        animation-name: intro-reveal;
        animation-fill-mode: forwards;
        animation-delay: 0.9s;
        animation-duration: 0.9s;
        transform: translate3d(0, 150%, 0);
        will-change: transform;
        @media (prefers-reduced-motion) {
          animation: none;
          transform: none !important;
        }
      }
    }
    .note {
      background: linear-gradient(
        91.08deg,
        #f9a026 -9.03%,
        #a686f2 27.88%,
        #592ac8 65.98%
      );
      -webkit-background-clip: text;
      -webkit-text-fill-color: transparent;
    }
  }
  .hero-image {
    position: absolute;
    top: 0;
    right: 0;
    object-fit: cover;
    z-index: 1;
    opacity: 0;
    animation: opacity-intro 0.9s linear forwards 1.2s;

    &.gartner-mq {
      top: -5%;

      img {
        width: 1400px;
        height: auto;
      }
    }

    img {
      margin: $spacing-96 0 0 0;
      transform: translateX(13%);

      @media (max-width: $breakpoint-md) {
        display: none;
      }
    }

    @media (max-width: $breakpoint-md) {
      position: relative;
    }

    &__mobile {
      img {
        width: 100%;
      }
    }
  }
}

@keyframes intro-reveal {
  from {
    transform: translate3d(0, 150%, 0);
  }
  to {
    transform: translate3d(0, 0%, 0);
  }
}

@keyframes opacity-intro {
  from {
    opacity: 0;
  }
  to {
    opacity: 1;
  }
}
</style>
